;compile with sjasmplus
	device zxspectrum128
        ORG #6000
begin
;	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;	ld hl,mf:call prm
;	jr $
	xor a:out ($FE),a
maplace=$B000
	ld hl,m1:call prm
	ld hl,m2:call prm
	ld hl,m3:call prm
	ld hl,m4:call prm
;	ld hl,m33:call prm
	
mnu_l:
;0
	ld a,$EF:in a,($FE):and 1:jp z,start_lvl
;1
	ld a,$F7:in a,($FE):and 1:jp z,sel_lvl

	jr mnu_l
sel_lvl:
	ld hl,m33:call prm
	ld de,0
	ld a,(lvl)
	dec a
	cp 10:jr c,no_10
	inc d
	sub 10
no_10:
	ld e,a
	call crs
;check keys
getk:
 ld a,$F7:in a,(#FE):and 16:jp z,mleft;5 is left
 ld a,$EF:in a,(#FE):and 4:jp z,mright;8 is right
 ld a,$EF:in a,(#FE):and 8:jp z,mup;7 is up
 ld a,$EF:in a,(#FE):and 16:jp z,mdown;6 is down
 
 ld a,$BF:in a,($FE):and 1:jp nz,getk
 
 	;call crs
 	ld a,d:or a:jr z,no10
 	ld a,10
no10:
	add a,e
	inc a
	ld (lvl),a
;	jr $
	call wp
	;ei:halt:halt:halt
	jp mnu_l

endk:
	ei:halt
	call crs
	call wp
	jp getk

mleft:
	ld a,e:or a:jp z,getk
	call crs
	dec e
	jp endk
mright:
	ld a,e:cp 10-1:jp z,getk
	call crs
	inc e
	jp endk
mup:
	ld a,d:or a:jp z,getk
	call crs
	dec d
	jp endk
mdown:
	ld a,d:cp 1:jp z,getk
	call crs
	inc d
	jp endk


;mm:
;	ei:halt:halt
;	ld a,nt_walk_l0,de,$4000:call drtile
;	ei:halt:halt
;	ld a,nt_walk_l1,de,$4000:call drtile
;	ei:halt:halt
;	ld a,nt_walk_l2,de,$4000:call drtile
;	jp mm
start_lvl:
;init vars
	xor a:ld (mgk),a
;	ld a,8,(mgk),a
	ld a,nt_walk_r0,(drct),a
	call drawlvl
	
	ld de,(pxy)
	call scrxy
	ex de,hl
	ld a,(drct):call drtile

glp:
	ld de,(pxy)

;R-restart
	ld a,$FB:in a,($FE)
	and 8:jp z,start_lvl
;N-next level
;	ld a,$7F:in a,($FE)
;	and 8:jp z,nxt_lvl

 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down
 jp glp

left:
 ld a,(drct):cp nt_walk_l0:jr z,cont_left
 ld a,nt_stay:call drwplyr
 ei:halt:halt:halt
 ld a,nt_walk_l0
 ld (drct),a
 call drwplyr
 ei:halt:halt:halt

 jp glp
cont_left:
	ld a,e:or a:jp z,glp;X=0?
	call mapxy
	ld a,(ix-1)
	cp nt_wall:jp z,l_wall
	cp nt_block:jp z,l_block
	cp nt_empty:jp z,l_empty
	cp nt_diamond:jp z,l_diamond
	cp nt_magic:jp z,l_magic
 jp glp
l_wall:
 jp glp
l_block:
;fire
;	ld a,e:cp 1:jp z,glp
	ld a,e:cp 1:jp nz,l_fire
	jp l_bm
l_fire:
	ld a,(ix-2)
	cp nt_wall:jp z,l_bw
	cp nt_block:jp z,l_bb
	cp nt_empty:jp z,l_be
	cp nt_diamond:jp z,l_bd
	cp nt_magic:jp z,l_bm
 jp glp

l_bw: ;block,wall
; jp glp
l_bb: ;block,block
; jp glp
l_bd:;block,diamond
; jp glp
l_bm:;block,magic
;checkfire
;	jr $
	call checkfire
	jp nz, glp
;mg-1
	ld a,(mgk)
	or a
	jp z,glp
	dec a
	ld (mgk),a
	call ay1
	ld (ix-1),nt_empty
	dec e
	call scrxy
;	ld (hl),$aa
;	jr $
	ex de,hl
;	jr $
	ld a,nt_expl0:call drwplyr2
;	jr $
	ld a,nt_expl1:call drwplyr2
;	jr $
	ld a,nt_expl2:call drwplyr2
;	jr $
	ld a,nt_empty:call drwplyr2
	call drstat
 jp glp

l_be:;block,empty
	dec e
	ld (ix-1),nt_empty
	ld (ix-2),nt_block
	call atrxy
	push hl
	pop ix
	ld a,(ix)
;	or 128
	ld (ix-1),a
	ld (ix-2),a
	ld (ix+31),a
	ld (ix+30),a
;	jr $
	call scrxy
	inc hl
	;ld (hl),$AA
	
	ld c,16
sbl1:
	push hl
	ld b,16
sbl2:
	push hl
	pop ix
	xor a
	rl(ix+0)
	rl(ix-1)
	rl(ix-2)
	rl(ix-3)
	call nbhl
	djnz sbl2
	pop hl
	ei
	halt
	dec c
	jp nz,sbl1

	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
 jp glp

l_empty:
	push de
	call scrxy
	dec hl
	ld ixl,0 ; number tile
	push hl
	call l_scroll
	pop hl
	dec hl
	call l_scroll
	pop de
	dec e
	ld (pxy),de
	jp glp
l_diamond:
	call ay2
	ld (ix-1),nt_empty
	dec e
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
	jp checkd;glp
l_magic:
	ld a,3,(mgk),a
	push de,ix
	call drstat
	pop ix,de
	jr l_diamond;jp glp

;=====================================================================
l_scroll:
;	ld ixl,0 ; number tile
	ld ixh,0 ;counter
ls:
	ld a,ixl
;*
	ld c,ixh
	bit 0,c:jr z,lskp
;*
	inc a
lskp:

	cp 3
	jr nz,no_ls
	xor a
no_ls:
	ld ixl,a
	add a,nt_walk_l0
	push hl
	ld l,a,h,0
	add hl,hl
	ld bc,tilea
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl),l,a
	inc hl
	ex de,hl
	pop hl

;DE=adr of tile,HL=screen
	ld a,16
	push hl
hujl:
	push af
;	xor a:ld (orl1+1),a
	push hl
;	call lbyte1
;	call lbyte1
	ex de,hl
	ld b,(hl):inc hl
	ld c,(hl):inc hl
	ex de,hl

	ld a,ixh
	or a:jp z,putl
	push ix
	xor a
scl:
	sla c
	rl b
	rl a
	dec ixh
	jr nz,scl
	pop ix
putl:
	ld (hl),a:inc hl
	ld (hl),b:inc hl
	ld (hl),c:inc hl
	pop hl
	call nbhl
	pop af
	dec a
	jp nz,hujl
	ei
	halt
	pop hl
	inc ixh
	ld a,ixh
	cp 8+1
	jp nz,ls
	ret
;=====================================================================
right:
 ld a,(drct):cp nt_walk_r0:jr z,cont_right
 ld a,nt_stay:call drwplyr
 	ei:halt:halt:halt

 ld a,nt_walk_r0
 ld (drct),a
 call drwplyr
 	ei:halt:halt:halt

 jp glp
cont_right:
 	ld a,e:cp 15:jp z,glp;right edge
	call mapxy
	ld a,(ix+1)
	cp nt_wall:jp z,r_wall
	cp nt_block:jp z,r_block
	cp nt_empty:jp z,r_empty
	cp nt_diamond:jp z,r_diamond
	cp nt_magic:jp z,r_magic
 jp glp
r_wall:
	jp glp
r_block:
;	ld a,e:cp 14:jp z,glp ; block,wall
	ld a,e:cp 14:jp nz,r_fire;glp ; block,wall
	jp rbm
r_fire:
	ld a,(ix+2)
;block,wall
	cp nt_wall:jp z,rbw
;block,block
	cp nt_block:jp z,rbb
;block,diamond
	cp nt_diamond:jp z,rbd
;block,magick
	cp nt_magic:jp z,rbm
;block,empty
	cp nt_empty:jp z,rbe
	jp glp
rbw:
;test fire
;	jp glp

rbb:
;test fire
;	jp glp
rbd:
;test fire
;	jp glp
rbm:
;test fire
	call checkfire
	jp nz, glp
;mg-1
	ld a,(mgk)
	or a
	jp z,glp
	dec a
	ld (mgk),a
	call ay1
	ld (ix+1),nt_empty
	inc e
	call scrxy
;	ld (hl),$aa
;	jr $
	ex de,hl
;	jr $
	ld a,nt_expl0:call drwplyr2
;	jr $
	ld a,nt_expl1:call drwplyr2
;	jr $
	ld a,nt_expl2:call drwplyr2
;	jr $
	ld a,nt_empty:call drwplyr2
	call drstat

	jp glp
rbe:
;scroll
;copy colors
	call atrxy
	inc hl,hl
	push hl
	pop ix
	ld a,(ix+0)
;	or 128
	ld (ix+2),a
	ld (ix+34),a
	ld (ix+3),a
	ld (ix+35),a
	
	call scrxy
	inc hl,hl
	
	ld c,16
brsc1:
	xor a
	ld b,16
	push hl,hl:pop ix
brsc2:
	rr(ix+0):rr(ix+1):rr(ix+2):rr(ix+3)
	push ix:pop hl
	call nbhl
	push hl:pop ix
	djnz brsc2
	pop hl
	ei
	halt
	dec c
	jp nz,brsc1
	
	call mapxy
	ld (ix+1),nt_empty
	ld (ix+2),nt_block

	call atrxy
	inc hl,hl
	ld a,$47;+128
	ld (hl),a:inc hl:ld (hl),a
	ld bc,31:add hl,bc
	ld (hl),a:inc hl:ld (hl),a
;	jr $
;	ld hl,maplace:call dl_2
;	jr $
	jp glp
r_empty:
	push de
	call scrxy
	;dec hl
	ld ixl,0 ; number tile
	push hl
	call r_scroll
	pop hl
	inc hl
	call r_scroll
	pop de
	inc e
	ld (pxy),de
	jp glp

r_diamond:
	call ay2
	ld (ix+1),nt_empty
	inc e
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
;check for diamonds
	jp checkd;glp
r_magic:
	ld a,3,(mgk),a
	push de,ix
	call drstat
	pop ix,de
	jr r_diamond

;	jr $
;	jp glp
;=====================================================================
r_scroll:
	ld ixh,0 ;counter
rs:
	ld a,ixl
;*
	ld c,ixh
	bit 0,c:jr z,rskp
;*
	inc a
rskp:
	cp 3
	jr nz,no_rs
	xor a
no_rs:
	ld ixl,a
	add a,nt_walk_r0
	push hl
	ld l,a,h,0
	add hl,hl
	ld bc,tilea
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl),l,a
	inc hl
	ex de,hl
	pop hl
;DE=adr of tile,HL=screen
	ld a,16
	push hl
hujr:
	push af
	push hl
	ex de,hl
	ld b,(hl):inc hl
	ld c,(hl):inc hl
	ex de,hl

	ld a,ixh
	or a:jp z,putr
	push ix
	xor a
scr:
	srl b
	rr c
	rr a
	dec ixh
	jr nz,scr
	pop ix
putr:
	ld (hl),b:inc hl
	ld (hl),c:inc hl
	ld (hl),a:inc hl
	pop hl
	call nbhl
	pop af
	dec a
	jp nz,hujr
	ei
	halt
	pop hl
	inc ixh
	ld a,ixh
	cp 8+1
	jp nz,rs
	ret
;=====================================================================
up:
	call mapxy
	ld a,(ix-16)
	cp nt_wall:jp z,u_wall
	cp nt_block:jp z,u_block
	cp nt_empty:jp z,u_empty
	cp nt_diamond:jp z,u_diamond
	cp nt_magic:jp z,u_magic
	jp glp
u_wall:
	jp glp
u_block:
	ld a,d:cp 1:jp z,glp
	ld a,(ix-32)
	cp nt_wall:jp z,u_bw
	cp nt_block:jp z,u_bb
	cp nt_empty:jp z,u_be
	cp nt_diamond:jp z,u_bd
	cp nt_magic:jp z,u_bm
	jp glp
u_bw:;block,wall
;check fire
;	jp glp
u_bb: ;block,block
;check fire
;	jp glp
u_bd: ; block,diamond
;check fire
;	jp glp
u_bm: ; block,magic
;check fire
	call checkfire
	jp nz, glp
;mg-1
	ld a,(mgk)
	or a
	jp z,glp
	dec a
	ld (mgk),a
	call ay1
	ld (ix-16),nt_empty
	dec d
	call scrxy
;	ld (hl),$aa
;	jr $
	ex de,hl
;	jr $
	ld a,nt_expl0:call drwplyr2
;	jr $
	ld a,nt_expl1:call drwplyr2
;	jr $
	ld a,nt_expl2:call drwplyr2
;	jr $
	ld a,nt_empty:call drwplyr2
	call drstat
	jp glp

u_be: ;block,empty
	dec d
	dec d
	call atrxy
	push hl
	pop ix
	ld a,(ix+64);$C6
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a
	
	call scrxy
	;ld (hl),$AA
	ld de,hl
	call nbde
	
	ld c,16
sbu1:
	push hl,de
	ld b,31
sbu2:
	ld a,(de),(hl),a:inc e,l
	ld a,(de),(hl),a:dec e,l
	call nbde,nbhl
	djnz sbu2
	xor a
	ld (hl),a:inc l:ld (hl),a
	ei
	halt
	pop de,hl
	dec c
	jp nz,sbu1
	
	ld de,(pxy)
	dec d
	call mapxy
	ld (ix),nt_empty
	ld (ix-16),nt_block

	ld de,(pxy)
	dec d
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
;	jr $
;	ld hl,maplace:call dl_2
;	jr $

	jp glp

u_empty:
	dec d
	ld (pxy),de

	call atrxy
	push hl
	pop ix
	ld a,$47
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a

	ld a,(drct),(usv1+1),a
	inc d
	call scrxy
	ld ixl,0
; scroll up
;	jr $
	ld c,16
sup1:
	ld b,16
	push hl
	ld a,ixl
;*
	bit 0,c:jr z,uskp
;*
	inc a
uskp:
	cp 3
	jr nz,nous
	xor a
nous:
	ld ixl,a
usv1: add a,0
	ld l,a,h,0
	add hl,hl
	ld de,tilea
	add hl,de
	ld e,(hl):inc hl:ld d,(hl)
	inc de;skip color
	pop hl
	call up_hl
	push hl
sup2:
	ld a,(de),(hl),a:inc de,l
	ld a,(de),(hl),a:inc de:dec l
	call nbhl
	djnz sup2
	ld (hl),0:inc l:ld (hl),0
	pop hl
	ei
	halt
	dec c
	jp nz,sup1
	jp glp

u_diamond:
	call ay2
	ld (ix-16),nt_empty
	dec d
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
	jp checkd

u_magic:
	ld a,3,(mgk),a
	push de,ix
	call drstat
	pop ix,de
	jr u_diamond
;	jp glp
 
down:
	call mapxy
	ld a,(ix+16)
	cp nt_wall:jp z,d_wall
	cp nt_block:jp z,d_block
	cp nt_empty:jp z,d_empty
	cp nt_diamond:jp z,d_diamond
	cp nt_magic:jp z,d_magic
	jp glp
d_wall:
	jp glp
d_block:
	ld a,(ix+32)
	cp nt_wall:jp z,d_bw
	cp nt_block:jp z,d_bb
	cp nt_empty:jp z,d_be
	cp nt_diamond:jp z,d_bd
	cp nt_magic:jp z,d_bm
	jp glp

d_bw: ;block wall
;	jp glp
d_bb: ; block,block
;check fire
;	jp glp
d_bd: ; block, diamond
;	jp glp
d_bm: ; block,magick
	call checkfire
	jp nz, glp
;mg-1
	ld a,(mgk)
	or a
	jp z,glp
	dec a
	ld (mgk),a
	call ay1
	ld (ix+16),nt_empty
	inc d
	call scrxy
	ex de,hl
;	jr $
	ld a,nt_expl0:call drwplyr2
;	jr $
	ld a,nt_expl1:call drwplyr2
;	jr $
	ld a,nt_expl2:call drwplyr2
;	jr $
	ld a,nt_empty:call drwplyr2
	call drstat
	jp glp

d_be: ; block, empty
	ld (ix+16),nt_empty
	ld (ix+32),nt_block
	inc d,d
	call atrxy
	push hl
	pop ix
	
	ld a,(ix-32)
;	or 128
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a
	
	dec d
	call scrxy
;scroll block
	ld c,16+1
sdb1:
	push hl
	ld b,16
	ld de,t_block+1
sdb2:
	ld a,(de),(hl),a:inc de,l
	ld a,(de),(hl),a:inc de:dec l
	call nbhl
	djnz sdb2
	pop hl
	call nbhl
	ei
	halt
	dec c
	jp nz,sdb1
	
	ld de,(pxy)
	inc d
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile
	jp glp


d_empty:
	inc d
	ld (pxy),de

	call atrxy
	push hl
	pop ix
	ld a,(ix-32);$47
;	or 128
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a

	ld a,(drct),(dsv1+1),a
	dec d
	call scrxy
	ld ixl,0
; scroll down
	ld c,16
sdp1:
	ld b,16
	push hl
	ld a,ixl
;*
	bit 0,c:jr z,doskp
;*
	inc a
doskp:
	cp 3
	jr nz,nods
	xor a
nods:
	ld ixl,a
dsv1: add a,0
	ld l,a,h,0
	add hl,hl
	ld de,tilea
	add hl,de
	ld e,(hl):inc hl:ld d,(hl)
	inc de;skip color
	pop hl
	ld (hl),0:inc l
	ld (hl),0:dec l
	call nbhl
	push hl
sdp2:
	ld a,(de),(hl),a:inc de,l
	ld a,(de),(hl),a:inc de:dec l
	call nbhl
	djnz sdp2
	pop hl
	ei
	halt
	dec c
	jp nz,sdp1
	jp glp
d_diamond:
	call ay2
	inc d
	call mapxy
	ld (ix+0),nt_empty
	call scrxy
	ex de,hl
	ld a,nt_empty
	call drtile

; check diamonds
checkd:
	ld hl,maplace,b,192
chb:
	ld a,(hl):inc hl
	cp nt_diamond
	jp z,glp
	djnz chb
nxt_lvl:
	call wp
	ld a,(lvl)
	inc a
	ld (lvl),a
	cp 21
	jp nz,start_lvl
	ld hl,mf:call prm
	jr $

d_magic:
	ld a,3,(mgk),a
	push de,ix
	call drstat
	pop ix,de
	jr d_diamond
;	jp glp
 
drwplyr:
	push de
	push af
	ld de,(pxy)
	call scrxy
	ex de,hl
	pop af
	call drtile
	pop de
	ret

checkfire:
	ld a,$EF:in a,($FE):and 1:ret z
	ld a,$7F:in a,($FE):and 4
	ret
ay1:
	push hl,bc
		ld	b, 13h
		ld	hl, 0
aylp1:
		push	bc
		ld	bc, 0FFFDh
		ld	a, l
		out	(c), a
		ld	bc, 0BFFDh
		ld	a, 13h
		out	(c), a
		inc	hl
		pop	bc
		djnz	aylp1
		pop bc,hl
		ret
ay2:
	push hl,bc
		ld	hl, aydu1
		xor	a
ay2lp:
		ld	bc, 0FFFDh
		out	(c), a
		push	af
		ld	a, (hl)
		inc	hl
		ld	b, 0BFh
		out	(c), a
		pop	af
		inc	a
		cp	0Eh
		jr	nz, ay2lp
		pop bc,hl
		ret
aydu1:
		db  70h
		db    0
		db    5
		db    0
		db 0B0h
		db    0
		db    0
		db  38h
		db  10h
		db  10h
		db  10h
		db    0
		db  28h
		db    1
		db    0
		db    0

;;;;;;;;;;;;;;;;;;;;routines;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Number in a to decimal ASCII
;adapted from 16 bit found in z80 Bits to 8 bit by Galandros
;Example: display a=56 as "056"
;input: a = number
;Output: a=0,value of a in the screen
;destroys af,bc (don't know about hl and de)
DispA:
;	ld	c,-100
;	call	Na1
	ld	c,-10
	call	Na1
	ld	c,-1
Na1:	ld	b,'0'-1
Na2:	inc	b
	add	a,c
	jr	c,Na2
	sub	c		;works as add 100/10/1
	push af		;safer than ld c,a
	ld	a,b		;char is in b
;	CALL	PUTCHAR	;plot a char. Replace with bcall(_PutC) or similar.
	ld (de),a:inc de
	pop af		;safer than ld a,c
	ret

stat:
 dw $4007 ; adr
 db $47 ; color
 db " Level:"
lvls: db "00"
 db " Magic:"
mkgs: db "00 "
 db $FF;end of text

crs:
	ld a,d
	add a,16
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,e
	add a,a
	add a,e
	add a,l
	ld l,a
	ld a,h
	adc a,$58
	ld h,a
	ld b,3
crsl:
	ld a,(hl)
	xor 3*8
	ld (hl),a
	inc hl
	djnz crsl
	ret
wk:;wait keypressed
	xor a
	in a,($fe)
	cpl
	and 31
	jr z,wk
	ret
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret

mf:
	dw $4801+128
	db $40+4*8
	db " Great! You solved all rooms "
	db $FF
m1:
	dw #4800+10
	db $44
	db "Magick, 2018"
	db $FF
m2:
	dw #4840+9
	db $47
	db "0.Start game"
	db $FF
m3:
	dw #4880+9
	db $47
	db "1.Choose Level"
	db $FF

m4:
	dw #48A0+34
	db $43
	db "code:g0blinish, gfx:jimbo_77"
	db $FF
	
m33:
	dw $5000
	db $47
	db " 1  2  3  4  5  6  7  8  9  10  "
	db " 11 12 13 14 15 16 17 18 19 20"
	db $FF
prm: ;HL=pointer at text
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld a,(hl):inc hl
	ld (mec+1),a

melp:
	push de
	exx
	pop de
;convert address to atributes
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
mec: ld (hl),0:inc hl
	exx
	ld a,(hl):inc hl
	push hl
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt
	add hl,bc
	push de
ch8lp:
	ld a,(hl),(de),a
	inc hl,d
	ld a,d
	and 7
	jr nz,ch8lp
	pop de
	pop hl
	inc e
	ld a,(hl):cp $FF
	jp nz,melp
	ret
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

up_hl:
     LD A,H
     DEC H
     AND 7
     ret nz
     LD A,L
     SUB 32
     LD L,A
     ret c
     LD A,H
     ADD A,8
     LD H,A
     ret

up_de:
     LD A,D
     DEC D
     AND 7
     ret nz
     LD A,E
     SUB 32
     LD E,A
     ret c
     LD A,D
     ADD A,8
     LD D,A
     ret

mapxy: ; in:DE=y.x,out:HL=adres
	ld l,d,h,0,b,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld c,e
	add hl,bc
	ld bc,maplace
	add hl,bc
	push hl
	pop ix
	ret

atrxy:
;in:DE=y.x
;out:HL=attributeadr,
		push de
		ld a,e:add a,a:ld e,a
		ld a,d:add a,a:ld d,a
		ld l,d,h,0,b,h
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		ld c,e
		add hl,bc
		ld bc,$5800
		add hl,bc
		pop de
		ret

;in:DE=y.x
;out:HL=screen adr, chars
scrxy:
		push de
		ld a,e:add a,a:ld e,a
		ld a,d:add a,a:ld d,a
		ld	hl, 4000h
		ld	a, d
		and	18h
		or	h
		ld	h, a
		ld	a, d
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		add	hl, de
		pop de
		ret

drawlvl:
	ld hl,(lvl),h,0
	add hl,hl
	ld de,levelt-2
	add hl,de

	ld a,(hl)
	inc hl
	ld h,(hl),l,a

;position player
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld (pxy),de
	
	ld de,maplace
	push de
	ld bc,255
	ldir
	pop hl
	
;	ld a,nt_magic,(maplace+8*16+8),a
dl_2:
	ld de, $4000

dl_lp:
	ld a,(hl):inc hl
	call drtile
	inc e,e
	ld a,e
	and 31
	jr nz,dl_lp

	ld a,e
	add a,32
	ld e,a
	jr nc,dl_lp
	ld a,d
	add a,8
	ld d,a
	cp $58
	jr nz,dl_lp
	
	call drstat
	ret
drstat:
	ld a,(lvl),de,lvls:call DispA
	ld a,(mgk),de,mkgs:call DispA

	ld hl,stat
	call prm
	ret

drwplyr2:
 ei:halt:halt:halt
drtile: ;A=tile#,de=scradress
	push de,hl

	ld l,a,h,0
	add hl,hl
	ld bc,tilea
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl),l,a
	
	ld a,(hl)
	inc hl;skip color
	ld (tc+1),a
	call tpart
	ld bc,$F820
	ex de,hl
	add hl,bc
	ex de,hl
	call tpart
	pop hl,de
	ret
tpart: ; part of tile,A=attribute
;attributes
;$40=010 00 000 $58=0101 10 00
;$48=010 01 000 $59=0101 10 01
;$50=010 10 000 $5A=0101 10 10
;[draw attributes]

 ld c,e
 ld a,d
 and %00011000
 srl a
 srl a
 srl a
 add a,$58
 ld b,a

tc: ld a,0
 ld (bc),a
 inc c
 ld (bc),a
 
 dup 8
	ldi
	ld a,(hl),(de),a
	inc hl
	dec de
	inc d
edup
	ret
;;vars
drct: db 0; tile# for draw
lvl db 1
mgk db 0; 0 or 3
pxy dw 0 ; player pos
levelt: ; levels adr
	dw l1,l2,l3,l4,l5,l6,l7,l8,l9,l10
	dw l11,l12,l13,l14,l15,l16,l17,l18,l19,l20
l1:
 db 1,10;X,Y
 incbin "l1.dat"

l2:
 db 1,5;X,Y
 incbin "l2.dat"

l3:
 db 8,7;X,Y
 incbin "l3.dat"

l4:
 db 13,2;X,Y
 incbin "l4.dat"

l5:
 db 14,10;X,Y
 incbin "l5.dat"

l6:
 db 6,2;X,Y
 incbin "l6.dat"
;check
l7:
 db 9,8;X,Y
 incbin "l7.dat"
l8:
 db 6,5;X,Y
 incbin "l8.dat"
l9:
 db 7,6;X,Y
 incbin "l9.dat"
l10:
 db 12,3;X,Y
 incbin "l10.dat"

l11:
 db 1,2;X,Y
 incbin "l11.dat"
l12:
 db 6,2;X,Y
 incbin "l12.dat"
l13:
 db 4,7;X,Y
 incbin "l13.dat"
l14:
 db 1,1;X,Y
 incbin "l14.dat"
l15:
 db 8,8;X,Y
 incbin "l15.dat"
l16:
 db 12,1;X,Y
 incbin "l16.dat"
l17:
 db 0,9;X,Y
 incbin "l17.dat"
l18:
 db 8,9;X,Y
 incbin "l18.dat"
l19:
 db 11,5;X,Y
 incbin "l19.dat"
l20:
 db 13,1;X,Y
 incbin "l20.dat"

tilea:
 dw t_empty,t_wall,t_block,t_diamond,t_magic,t_walk_l0,t_walk_l1,t_walk_l2,t_walk_r0,t_walk_r1,t_walk_r2,t_stay
 dw t_expl0,t_expl1,t_expl2
tiles:
t_empty:
 db $47 ; attribute color
 ds 32
t_wall:
 db $42
 incbin "t_wall.bin"
t_block:
 db $46
 incbin "t_block.bin"
t_diamond:
 db $45
 incbin "t_diamond.bin"
t_magic:
 db $43
 incbin "t_magic.bin"

t_walk_l0:
 db $47
 incbin "t_walk_l00.bin"
t_walk_l1:
 db $47
 incbin "t_walk_l10.bin"
t_walk_l2:
 db $47
 incbin "t_walk_l20.bin"
 
t_walk_r0:
 db $47
 incbin "t_walk_r00.bin"
t_walk_r1:
 db $47
 incbin "t_walk_r10.bin"
t_walk_r2:
 db $47
 incbin "t_walk_r20.bin"
t_stay:
 db $47
 incbin "t_stay0.bin"
t_expl0:
 db $42
 incbin "t_expl0.bin"
t_expl1:
 db $46
 incbin "t_expl1.bin"
t_expl2:
 db $47
 incbin "t_expl2.bin"


fnt:incbin "Metallion06.fnt"
nt_empty=(t_empty-tiles)/33
nt_wall=(t_wall-tiles)/33
nt_block=(t_block-tiles)/33
nt_diamond=(t_diamond-tiles)/33
nt_magic=(t_magic-tiles)/33
nt_walk_l0=(t_walk_l0-tiles)/33
nt_walk_l1=(t_walk_l1-tiles)/33
nt_walk_l2=(t_walk_l2-tiles)/33
nt_walk_r0=(t_walk_r0-tiles)/33
nt_walk_r1=(t_walk_r1-tiles)/33
nt_walk_r2=(t_walk_r2-tiles)/33
nt_stay=(t_stay-tiles)/33
nt_expl0=(t_expl0-tiles)/33
nt_expl1=(t_expl1-tiles)/33
nt_expl2=(t_expl2-tiles)/33
end
	display /d,end-begin
	savesna "!magic.sna",begin
	savebin "magic.code",begin,end-begin
